//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop


#include <sys\stat.h>
#include <shlobj.h>
#include <WindowsX.h>
#include <registry.hpp>
#include <io.h>
#include <assert.h>

#include "KheperaLaunch.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cdiroutl"
#pragma resource "*.dfm"

TForm1 *Form1;



//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    //Initialize globals
    PlatformChosen = Unselected;
    Application->Title = "K-Team Project Management";
    Form1->Caption = "K-Team Project Management";
    SetEnvPath();
}

//---------------------------------------------------------------------------
void TForm1::SetEnvPath()
{
    // Set all from GetCurrentDirectory
    char directory[32];

    if (!GetCurrentDirectory(sizeof(directory), directory))
     {
      ShowMessage("Cannot get current directory, please rerun the application.");
     }

    /* Current Directory Path */
    WorkDir = directory;
                                                                                      
    /* Path of Source Navigator EXE */
    SN = WorkDir + "\\SN451\\bin\\snavigator.exe";

    /* PATH Environment Variable Modification */
    String OldPath = getenv("PATH");

    String InstVar = "PATH="
                      + OldPath + ";"
                      + WorkDir + "\\BIN;"
                      + WorkDir + "\\JAVA\\BIN;"
                      + WorkDir + "\\LIB\\GCC-LIB\\M68K-N~1\\EGCS-2~1.60\\;";
    putenv(InstVar.c_str());

    /* MAKE_MODE Environment Variable Modification */
    InstVar = "MAKE_MODE=UNIX";
    putenv(InstVar.c_str());

    /* KPRJ Environment Variable Modification: Used by Makefiles */
    String UnxWorkDir;
    Dos2Unix(UnxWorkDir,WorkDir);
    InstVar = "KPRJ=" + UnxWorkDir;
    putenv(InstVar.c_str());
}


//---------------------------------------------------------------------------
void __fastcall TForm1::TheKheperaClick(TObject *Sender)
{
 PlatformChosen = Khepera;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TheKoalaClick(TObject *Sender)
{
 PlatformChosen = Koala;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TheKameleonClick(TObject *Sender)
{
 PlatformChosen = Kameleon;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ThePioneerClick(TObject *Sender)
{
 PlatformChosen = Pioneer;
}

//--------------------------------------------------------------------------
void __fastcall TForm1::NewTemplClick(TObject *Sender)
{
  // do not work
  if (PlatformChosen != Unselected)
   {
    // Get New Directory Name
    FileOpenDlg->InitialDir = WorkDir;
    FileOpenDlg->Options << ofHideReadOnly;
    FileOpenDlg->Filter = "*";
    if (FileOpenDlg->Execute())
     {
      // Create the Directory
      String NewDir = FileOpenDlg->FileName;

      // If NT do security stuff
      SECURITY_ATTRIBUTES sa;

      if (IsWindowsNT())
       {
        sa.nLength = sizeof(SECURITY_ATTRIBUTES);
        sa.bInheritHandle = true;
        sa.lpSecurityDescriptor = 0;
       }

      if ( !CreateDirectory(NewDir.c_str(), &sa) )
       {
        ShowMessage("Erreur lors de la cration du rpertoire : "+NewDir);
        exit(0);
       }

      String TemplFile = WorkDir + "\\" + PlatformName[PlatformChosen] + "\\examples\\Template.c";
      String NewKFile, Base;

      GetBaseName(Base,NewDir);
      NewKFile = NewDir + "\\" + Base + ".c";

      if ( !CopyFile(TemplFile.c_str(), NewKFile.c_str(), 1) )
       {
        ShowMessage("Erreur lors de la copie du fichier C patron : "+TemplFile+" vers "+NewKFile);
        exit(0);
       }

      TemplFile = WorkDir + "\\" + PlatformName[PlatformChosen] + "\\examples\\Makefile";
      NewKFile = NewDir + "\\" + "Makefile";

      if ( !CopyFile(TemplFile.c_str(), NewKFile.c_str(), 1) )
       {
        ShowMessage("Erreur lors de la copie du fichier Make patron : "+TemplFile+" vers "+NewKFile);
        exit(0);
       }

      StartProcess(SN+" --batchmode --create "+NewDir + "\\" + Base + ".proj");
      StartProcess(SN+" "+NewDir + "\\" + Base + ".proj");
      exit(0);
     }

    }
    else ShowMessage("Choisissez une plateforme, SVP !");
}

//---------------------------------------------------------------------------
void __fastcall TForm1::NewProjectClick(TObject *Sender)
{
  if (PlatformChosen != Unselected)
   {
    // Get New Directory Name
    FileOpenDlg->InitialDir = WorkDir;
    FileOpenDlg->Options << ofHideReadOnly;
    FileOpenDlg->Filter = "*.c;*.cc;*.s";
    if (FileOpenDlg->Execute())
     {
      // Create the Directory
      // Direrctory is supposed to be without any suffix !!!!
      String CodeFile = FileOpenDlg->FileName;
      String KDir,Base, TemplFile, NewKFile;
      GetDirName(KDir,CodeFile);
      GetBaseName(Base,KDir);

      // Verify that file is an existing directory or c file !!!!
      TemplFile = WorkDir + "\\" + PlatformName[PlatformChosen] + "\\examples\\Makefile" ;
      NewKFile = KDir + "\\Makefile";

      if ( !CopyFile(TemplFile.c_str(), NewKFile.c_str(), 1) )
       {
        ShowMessage("Erreur lors de la copie du fichier Make patron : "+TemplFile+" vers "+NewKFile);
        exit(0);
       }

      // Create Project
      StartProcess(SN+" -b -c "+KDir+"\\"+Base+".proj");

      // Start Source Navigator
      StartProcess(SN+" "+KDir+"\\"+Base+".proj");

      exit(0);
     }

    }
    else ShowMessage("Choisissez une plateforme, SVP !");

}

//---------------------------------------------------------------------------
void __fastcall TForm1::ExistingProjectClick(TObject *Sender)
{
 StartProcess(SN);
 exit(0);
}


//---------------------------------------------------------------------------
void TForm1::GetDirName(String& KDir, const String Full)
{
      // Extract the base name, i.e. the directory name
      char *cur, *newer;
      int i, slashpos;

      cur = Full.c_str();
      newer = (char *)malloc(sizeof(char)*strlen(cur));
      strcpy(newer,cur);

      for (i=0;*cur != '\0';cur++,i++)
        if (*cur == '\\') slashpos=i;

      newer[slashpos]='\0';
      KDir = newer;
}
//---------------------------------------------------------------------------
void TForm1::Dos2Unix(String& UnxWorkDir, const String WorkDir)
{
      // Extract the base name, i.e. the directory name
      char *cur, *newer;

      cur = WorkDir.c_str();
      newer = (char *)malloc(sizeof(char)*strlen(cur));
      strcpy(newer,cur);
      cur = newer;

      for (;*cur != '\0';cur++)
        if (*cur == '\\') *cur='/';

      UnxWorkDir = newer;
}

void TForm1::GetBaseName(String& Base, const String Full)
{
      // Extract the base name, i.e. the directory name
      char *full, *base;

      for (full = Full.c_str();*full != '\0';full++)
        if (*full == '\\') base=full+1;
      Base = base;
}

void TForm1::StartProcess(const String Cmd)
{
    Screen->Cursor = crHourGlass;

    // Initialize STARTUPINFO struct
    STARTUPINFO si;
    memset(&si, 0, sizeof(STARTUPINFO));
    si.cb = sizeof(STARTUPINFO);
    si.dwFlags = STARTF_USESHOWWINDOW;
    si.wShowWindow = SW_HIDE;

    PROCESS_INFORMATION pi;

    if( !CreateProcess(NULL, Cmd.c_str(), NULL, NULL, TRUE, NULL, NULL, NULL, &si, &pi))
     {
      ShowMessage("Impossible de lancer la commande "+Cmd);
      exit(0);
     }

    CloseHandle(pi.hThread);
    WaitForSingleObject(pi.hProcess, INFINITE);

    // Process cleanup
    CloseHandle(pi.hProcess);
    Screen->Cursor = crDefault;
}

//---------------------------------------------------------------------------
bool TForm1::IsWindowsNT()
{
	OSVERSIONINFO osv;
    osv.dwOSVersionInfoSize = sizeof(osv);
    GetVersionEx(&osv);
    return (osv.dwPlatformId == VER_PLATFORM_WIN32_NT);
}


//---------------------------------------------------------------------------

