//---------------------------------------------------------------------------
#ifndef KheperaLaunchH
#define KheperaLaunchH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "cdiroutl.h"
#include <Grids.hpp>
#include <Outline.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------

typedef enum platform {Khepera, Koala, Kameleon, Pioneer, Unselected} Platform;




class TForm1 : public TForm
{
__published:	// Composants grs par l'EDI
    TButton *NewTempl;
    TButton *NewProject;
    TButton *ExistingProject;
    TRadioButton *TheKhepera;
    TRadioButton *TheKameleon;
    TRadioButton *TheKoala;
    TRadioButton *ThePioneer;
    TOpenDialog *FileOpenDlg;
    TFindDialog *FindDialog1;
    void __fastcall TheKheperaClick(TObject *Sender);
    void __fastcall TheKoalaClick(TObject *Sender);
    void __fastcall TheKameleonClick(TObject *Sender);
    void __fastcall ThePioneerClick(TObject *Sender);
    void __fastcall ExistingProjectClick(TObject *Sender);
    void __fastcall NewTemplClick(TObject *Sender);
    void __fastcall NewProjectClick(TObject *Sender);
private:	// Dclarations de l'utilisateur
    String WorkDir;
    String BinPth;
    String LibPth;
    String IncPth;
    String ObjPth;
    TStringList *ProjectList;
    Platform PlatformChosen;
    String NewTemplateDir;
    String NewDirectory;
    String PrevProject;
    String SN;
    bool NewTemplateDirSelected;
    bool NewDirSelected;
    bool PrevProjectSelected;

public:		// Dclarations de l'utilisateur
    __fastcall TForm1(TComponent* Owner);
    void SetEnvPath(void);
    void StartProcess(const String command);
    void GetBaseName(String& Base, const String Full);
    void GetDirName(String& Dir, const String Full);
    void Dos2Unix(String& Dir, const String Full);
    bool IsWindowsNT(void);
};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------

static char *PlatformName[]={"khepack51", "koapack115", "rebpack113", "vvpack206"};

#endif
